现在的位置: 首页 > 综合 > 正文

【字典树】 hdu1800 Flying to the Mars

2018年01月14日 ⁄ 综合 ⁄ 共 2793字 ⁄ 字号 评论关闭

Flying to the Mars

http://acm.hdu.edu.cn/showproblem.php?pid=1800



Problem Description


In the year 8888, the Earth is ruled by the PPF Empire . As the population growing , PPF needs to find more land for the newborns . Finally , PPF decides to attack Kscinow who ruling the Mars . Here the problem comes! How can the soldiers reach the Mars ? PPF
convokes his soldiers and asks for their suggestions . “Rush … ” one soldier answers. “Shut up ! Do I have to remind you that there isn’t any road to the Mars from here!” PPF replies. “Fly !” another answers. PPF smiles :“Clever guy ! Although we haven’t got
wings , I can buy some magic broomsticks from HARRY POTTER to help you .” Now , it’s time to learn to fly on a broomstick ! we assume that one soldier has one level number indicating his degree. The soldier who has a higher level could teach the lower , that
is to say the former’s level > the latter’s . But the lower can’t teach the higher. One soldier can have only one teacher at most , certainly , having no teacher is also legal. Similarly one soldier can have only one student at most while having no student
is also possible. Teacher can teach his student on the same broomstick .Certainly , all the soldier must have practiced on the broomstick before they fly to the Mars! Magic broomstick is expensive !So , can you help PPF to calculate the minimum number of the
broomstick needed .
For example : 
There are 5 soldiers (A B C D E)with level numbers : 2 4 5 6 4;
One method :
C could teach B; B could teach A; So , A B C are eligible to study on the same broomstick.
D could teach E;So D E are eligible to study on the same broomstick;
Using this method , we need 2 broomsticks.
Another method:
D could teach A; So A D are eligible to study on the same broomstick.
C could teach B; So B C are eligible to study on the same broomstick.
E with no teacher or student are eligible to study on one broomstick.
Using the method ,we need 3 broomsticks.
……

After checking up all possible method, we found that 2 is the minimum number of broomsticks needed. 

 


Input
Input file contains multiple test cases. 
In a test case,the first line contains a single positive number N indicating the number of soldiers.(0<=N<=3000)
Next N lines :There is only one nonnegative integer on each line , indicating the level number for each soldier.( less than 30 digits);
 


Output
For each case, output the minimum number of broomsticks on a single line.
 


Sample Input
4 10 20 30 04 5 2 3 4 3 4
 


Sample Output
1 2

//无奈,扩展KMP怎么都看不懂,智商果然是硬伤啊,换个字典树继续往下学。

题目大意:
给你一堆士兵的等级,等级高的的士兵可以当等级小的士兵的师傅,一个士兵最多一个师傅(可以没有),一个师傅最多1个徒弟(可以没有),如果是师徒关系,可以用一把扫帚练习技能,问你如果全部士兵都用过扫帚练习时最小需要的扫帚数量。
解题思路:
实质就是字典树的应用。如果所有士兵等级都不同,则就可以用一条师徒链,所以就需要一把扫帚,而如果出现2个相同等级的士兵,则需要开辟另外一条师徒链,以此类推,发现只要求出等级相同的最多士兵数,就需要多少把扫帚。

#include<cstdio>
#include<cstring>
#include<algorithm>
using namespace std;
struct Trie
{
    int cnt;
    Trie *child[10];
    Trie(){cnt=0;memset(child,NULL,sizeof(child));}
}*root;
int ans;
void insert(char *s)
{
    int id;
    Trie *p=root;
    for(int i=0;s[i];)
    {
        id=s[i]-'0';
        if(!p->child[id])
           p->child[id]=new Trie();
        p=p->child[id];
        ++i;
    }
    p->cnt++;
    ans=max(ans,p->cnt);
}
int main()
{
    char s[35];
    int n,pos;
    for(;~scanf("%d",&n);)
    {
        ans=0;
        root=new Trie();
        for(int i=0;i<n;++i)
        {
            scanf("%s",s);
            pos=0;
            for(;s[pos]=='0';++pos);
            insert(s+pos);
        }
        printf("%d\n",ans);
    }
    return 0;
}

抱歉!评论已关闭.